<?
    // Usage:
    // $ssm = new Sosumi('username', 'password');
    // $location_info = $ssm->locate(<device number>);
    // $ssm->sendMessage('Your Message', true, <device number>, 'Important Message');
    //
$loc_lat_home = xx.xxxxxxx;                      // Latitude Zuhause
$loc_lon_home = xx.xxxxxxx;                      // Longitude Zuhause
$debug = false;                                       // echo-Meldungen zu debugging aktivieren

include("func_distance.ips.php");           // Function zur Berechnung
include("class_Sosumi.ips.php");           // MobilMe-API
include("IPSInstaller.ips.php");

$timestamp = time(); // aktueller Zeitstempel
$ssm = new Sosumi('Email', 'PW', $debug);   // Apple-Account, Account-Passwort
$id = 0;

foreach ( $ssm->devices as $geraete )
{
	$timeout = 30;    // Timeout fuer neue Position

	while(true)
	{
		$ssm->devices[$id]->latitude  = false; // auf false damit locate funktioniert
		$ssm->devices[$id]->longitude = false; // auf false damit locate funktioniert

		$loc = $ssm->locate($id, 15);

		$id_timestamp = strtotime($loc['timestamp']);   // Zeitstempel der Position

		$diff = $id_timestamp - $timestamp;    // Differenz zum Startzeitpunkt des Scriptes

		if ( $diff > 0 ) break;       // wenn Zeitstempel neuer dann raus

		sleep(5);
		$timeout = $timeout - 5 ;     // warten
		if ( $timeout < 0 )
		break;                     // Timeout
	}

	$id++;

	// print_r($loc);
	
}
        
//$loc = $ssm->locate(0, 5);
$loc = $ssm->locate();
//$ssm->sendMessage('Testnachricht', false, 0, 'Testbetreff');

// print_r($loc);

// erstes Gert abfragen
$loc = $ssm->locate(0);

// Ab hier theoretisch nichts mehr ndern
$parent_id = IPS_GetParent($IPS_SELF);
IPS_SetPosition($IPS_SELF, 999);
IPS_SetHidden($IPS_SELF, true);
$devicename = UTF8_Decode($loc['name']);

if($debug) {
 echo $loc['latitude'];
 echo "\n";
 echo $loc['longitude'];
 echo "\n";
 echo ($loc['timestamp']);
 echo "\n";
 echo $loc['accuracy'];
 echo "\n";
 echo date("H:i:s");
 echo "\n";
 echo $loc['exception'];
 echo "\n";
 echo UTF8_Decode($loc['name']);
 echo "\n";
 echo $loc['charging'];
 echo "\n";
 echo $loc['battlevel'];
 echo "\n";
 echo $loc['status'];
 echo "\n";
}
// $Profil_Name = array('Zuhause', 'Abwesend');
// $Profil_Color = array(0 => 0xaaaaaa, 1 => 0xaaaaaa);
// CreateProfile_Associations(".SosumiZuhause", $Profil_Name, "", $Profil_Color);
// SetValue(CreateVariable("Maps", 3, $parent_id, 30, "~HTMLBox"), "<iframe src=\"user/iphone/map.php?lat=".$loc['latitude']."&lng=".$loc['longitude']."&devicename=".$devicename."&altitude=".$loc['accuracy']."&date=".$loc['timestamp']."\" border=\"0\" frameborder=\"0\" style=\"top:0pt; bottom:0pt; left:0pt; right:0pt; width:100%; height:400px;\"/></iframe>");
//SetValueString(36289 /*[Objekt #36289 existiert nicht]*/ , "<iframe src=\"user/iphone/map.php?lat=".$loc['latitude']."&lng=".$loc['longitude']."&devicename=".$devicename."&altitude=".$loc['accuracy']."&date=".$loc['timestamp']."\" border=\"0\" frameborder=\"0\" style=\"top:0pt; bottom:0pt; left:0pt; right:0pt; width:100%; height:400px;\"/></iframe>");
$diff = distance($loc_lat_home, $loc_lon_home, $loc['latitude'], $loc['longitude']);
//$diff = 5.1;
if($debug) echo $diff;
SetValue(CreateVariable("Entfernung", 2, $parent_id, 24, "Distance"), $diff);
//SetValue(55107 /*[Objekt #55107 existiert nicht]*/, $diff);

if($diff > 0.3) {             // Wenn Entfernung grer 1.0km dann abwesend
 // SetValue(CreateVariable("Zuhause", 1, $parent_id, 10, ".SosumiZuhause"), 1);
 SetValue(CreateVariable("Zuhause", 0, $parent_id, 10, "~Presence"), False);
}
else
{
 // SetValue(CreateVariable("Zuhause", 1, $parent_id, 10, ".SosumiZuhause"), 0);
 SetValue(CreateVariable("Zuhause", 0, $parent_id, 10, "~Presence"), True);
}

SetValue(CreateVariable("Latitude", 2, $parent_id, 110, ""), $loc['latitude']);
SetValue(CreateVariable("Longitude", 2, $parent_id, 120, ""), $loc['longitude']);
SetValue(CreateVariable("Timestamp", 3, $parent_id, 130, "~String"), $loc['timestamp']);
SetValue(CreateVariable("chargingStatus", 3, $parent_id, 140, "~String"), $loc['chargingStatus']);
SetValue(CreateVariable("batteryLevel", 2, $parent_id, 150, ""), $loc['batteryLevel']);

// SetValue(CreateVariable("Meldung", 3, $parent_id, 25, "~String"), $loc['exception']);
$timer = CreateTimer_CyclicByMinutes("Timer for iPhone", $IPS_SELF, 30);
if($debug) echo $timer;

// Erneutes triffern des Timers
Switch ($_IPS['SENDER']) {
	Case "Variable": 	// $_IPS['VARIABLE']
	   $minute = 10;
	   break;
	Default:
		if ($diff > 100) {$minute = 60;} else {$minute = 30;}
	   break;
}

IPS_SetEventCyclic($timer, 0, 0, 0, 2, 2 , $minute);
SetValue(CreateVariable("Abfragezyklus", 1, $parent_id, 26, "Zeit"), $minute);

?>